# xDevs.com Python 10V test for 3458A
# http://xdevs.com/guide/ni_gpib_rpi/
import os.path
import sys
import Gpib
import time
import ftplib
import numbers
import signal
from Adafruit_BME280 import *

root_dir = '/repo/3458/'
fileName4 = root_dir + '4142_1g_test1_tin.csv'

cnt = 0
tread = 20
reflevel = 10E3
refhp = 10000.406
res_delta = 0.0
curr1 = 0.0000
curr2 = 0.0000
curr3 = 0.0000
curr4 = 0.0000
volt1 = 1.00000
volt2 = 1.00000
volt3 = 1.00000
volt4 = 1.00000
volt_p1  = 15.000
volt_p2 = -15.000
vmeas1 = 0
vmeas2 = 0

tec_start = 24
tec_stop = 50
tec_step = 0.1
tec_time = 50

tec_rtd = 0.3
temp = 18.0
res_rtd = 0.3
exttemp = 25.0
rh = 50.0
pascals = 100000.00
hectopascals = 1000.00
tset = 18.0
dline = 0

class Timeout():
  """Timeout class using ALARM signal"""
  class Timeout(Exception): pass

  def __init__(self, sec):
    self.sec = sec

  def __enter__(self):
    signal.signal(signal.SIGALRM, self.raise_timeout)
    signal.alarm(self.sec)

  def __exit__(self, *args):
    signal.alarm(0) # disable alarm

  def raise_timeout(self, *args):
    raise Timeout.Timeout()

class tec_meter():
    temp = 38.5
    data = ""
    ppm = 0.0
    status_flag = 1
    temp_status_flag = 1
    global exttemp
    global rh
    global hectopascals
    global tec_rtd

    def __init__(self,gpib,reflevel,name):
        self.gpib = gpib
        self.inst = Gpib.Gpib(0,self.gpib, timeout=90) # SCPI GPIB Address = self.gpib
        self.reflevel = reflevel
        self.name = name
	self.tec_rtd = tec_rtd
        self.init_inst()

    def init_inst(self):
        # Setup SCPI DMM
	#self.inst.write("*rst") #reset TEC controller
	#self.inst.write("*CLR")
	#Set temperature transducer to thermistor and 4-wire sense mode
	self.inst.write(":sens:temp:tran rtd")      #select thermistor
	self.inst.write(":sens:temp:rtd:type user") #10 kOhm thermistor
	self.inst.write(":sens:temp:rtd:alph 0.00375") #10 kOhm thermistor
	self.inst.write(":sens:temp:rtd:beta 0.160") #10 kOhm thermistor
	self.inst.write(":sens:temp:rtd:delt 1.605") #10 kOhm thermistor
	self.inst.write(":sens:temp:rtd:rang 1000") #10 kOhm thermistor
	self.inst.write(":sens:temp:curr 8.333e-4") #10 kOhm thermistor
	self.inst.write(":syst:rsen on")            #4-wire mode enabled
	#Set voltage limit
	self.inst.write(":sour:volt:prot 10.0") #+9.5V limit
	#Set current limit
	self.inst.write(":sens:curr:prot 5.0") #2.5A limit
	#Set temperature limit*
	self.inst.write(":sour:temp:prot:high 65")  #75C max temp
	self.inst.write(":sour:temp:prot:low 5")   #15C min temp
	self.inst.write(":sour:temp:prot:state ON") #enable temp #protection (default)
        #self.inst.write(":FORM:ELEM READ")
        self.inst.write(":DISP:WIND:TEXT:DATA \"               \";STAT OFF;")
        self.inst.write(":DISP:WIND2:TEXT:DATA \"          \";STAT OFF;")
        #kei.write("READ?")

    def cfg_temp(self):
	self.inst.write(":sour:temp 23.4") #set temp
	time.sleep(0.1)
        self.inst.write(":OUTP ON")
	time.sleep(0.1)
	tec_rtd = 5.3

    def off_temp(self):
	self.inst.write(":sour:temp 23.4") #set temp
	time.sleep(0.1)
        self.inst.write(":OUTP OFF")
	time.sleep(0.1)
	tec_rtd = 5.3

    def deduct_tmp(self,tmp):
	string = float(tmp)
	print ("Setting %2.1f" % string)
	self.inst.write(":sour:temp %2.1f" % string) 
	time.sleep(0.1)
        self.inst.write(":OUTP ON")
	time.sleep(0.1)

    def read_data(self,cmd):
        data_float = 0.0
        data_str = ""
        self.inst.write(cmd)
        time.sleep(0.1)
	try:
            with Timeout(90):
		time.sleep(0.1)
                data_str = self.inst.read()
        except Timeout.Timeout:
            print ("Timeout exception from dmm %s on read_data() inst.read()\n" % self.name)
            return (0,float(0))
        #print ("Reading from dmm %s = %s" % (self.name,data_str))
        try:
            data_float = float(data_str)
        except ValueError:
            print("Exception thrown by dmm %s on read_data() - ValueError = %s\n" % (self.name,data_str))
            return (0,float(0)) # Exception on float conversion, 0 = error
        return (1,data_float) # Good read, 1 = converted to float w/o exception

    def get_data(self):
        self.status_flag,data = self.read_data(":MEAS:TEMP?")
    	time.sleep(0.1)
        tec_rtd = float(data)
        if (self.status_flag):
            self.data = data
            self.ppm = ((float(self.data) / self.reflevel)-1)*1E6
    	return self.data

    def get_data_status(self):
        return self.status_flag

    def write_data(self,fileHandle):
	#print ("TEC TC:%2.3f " % (float(self.data) ) )
	tec_rtd = float(self.data)
	fileHandle.write(";0.0;%2.3f\r\n" % tec_rtd);
        #print time.strftime("%d/%m/%Y-%H:%M:%S;") + ("\033[1;31m[%8d]: %2.8f , dev %4.2f ppm,\033[1;39m  EXT_T:%3.2f , RH:%3.2f , Press:%4.2f hPa" % (cnt, float(self.data),float(self.ppm),float(exttemp),float(rh),float(hectopascals) ) )
        #fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%16.8f;%16.8f;%3.1f;%3.2f;%3.2f;%4.2f;\r\n" % (float(self.data),float(self.reflevel),float(self.ppm),float(exttemp),float(rh),float(hectopascals) ) ))

    def print_ppm(self):
        #self.inst.write(":DISP:WIND2:TEXT:DATA \"%3.3f ppm\"" % float(self.ppm))
	tec_rtd = float(self.data)
	#print ("%2.3f" % tec_rtd )
	#self.inst.write(":DISP:WIND2:TEXT:DATA \"  \"")

class smu_src():
    temp = 38.5
    data = ""
    ppm = 0.0
    status_flag = 1
    temp_status_flag = 1
    global exttemp
    global rh
    global hectopascals
    global tec_rtd

    def __init__(self,gpib,reflevel,name):
        self.gpib = gpib
        self.inst = Gpib.Gpib(0,self.gpib, timeout=90) # SCPI GPIB Address = self.gpib
        self.reflevel = reflevel
        self.name = name
        self.init_inst()

    def init_inst(self):
        # Setup SCPI 6221
	nplc = 25
	self.inst.write("*rst\n") #reset TEC controller
	self.inst.write("CM1\n")
	self.inst.write("CN2\n")
	self.inst.write("CN3\n")
	self.inst.write("CN5\n")
	self.inst.write("CN6\n")
	self.inst.write("AV-%d,1\n" % nplc)
	print ("\033[2J\033[1;1HNPLC %d" % (nplc)),

    def self_cal(self,ch):
	self.inst.write("CL%d\n" % ch)
	self.inst.write("CA%d\n" % ch)
	print ("\033[1;18H \033[43;31m SELF_CAL CH%d \033[49;39m" % (ch))
	time.sleep(10)
	self.inst.write("CN%d\n" % ch)
	print ("\033[1;18H \033[49;39m              \033[49;39m")

    def src_on(self,ch):
	self.inst.write("DZ%d\n" % ch)
	self.inst.write("CN%d\n" % ch)

    def src_meas_mode(self,ch,mode):
	self.inst.write("MM%d,%d\n" % (mode, ch))
    
    def src_off(self,ch):
	self.inst.write("DZ%d\n" % ch)
	self.inst.write("CL%d\n" % ch)

    def src_curr(self, ch, value, rang, cmpl):
	rng_str = ["AUTO-IRNG", "", "", "", "", "", "", "", "", "", "", "  1 nADC ", " 10 nADC ", " 100 nADC", "  1 uADC ", " 10 uADC ", "100 uADC ", "  1 mADC ", " 10 mADC ", "100 mADC ", "  1 ADC  "]
	# 0 - autorange, 11 - 1nA, 12 - 10nA, 13 - 100nA, 14 - 1ua, 15 - 10ua, 16 - 100ua, 17 - 1ma, 18 - 10ma, 19 - 100ma, 20 - 1A
	# cmpl           0 - 200v                                                                                 100v        14v
	print ("\033[%d;40H \033[%d;1mIset = %9.6E A, %s Vcmpl = %E VDC\033[39;0m" % (ch+1, ch+30, value, rng_str[rang], cmpl))
	self.inst.write("DI%d,%d,%9.6e,%e\n" % (ch, rang, value, cmpl))

    def src_volt(self, ch, value, rang, cmpl):
	rng_str = ["AUTO-VRNG", "", "", "", "", "", "", "", "", "", "", "  2 VDC  ", " 20 VDC  ", " 40 VDC  ", "100 VDC  ", "200 VDC  "]
	# 0 - autorange, 11 - 2V, 12 - 20V, 13 - 40V, 14 - 100V, 15 - 200V
	# cmpl                     1A       350mA     125mA         50mA
	print ("\033[%d;40H \033[%d;1mVset = %9.6E V, %s Icmpl = %E ADC\033[39;0m" % (ch+1, ch+30, value, rng_str[rang], cmpl))
	self.inst.write("DV%d,%d,%9.6e,%e\n" % (ch, rang, value, cmpl))

    def vs_volt(self, ch, value, rang):
	rng_str = ["AUTO-VRNG", "", "", "", "", "", "", "", "", "", "", "         ", " 20 VDC  ", " 40 VDC  "]
	# 0 - autorange, 11 - 2V, 12 - 20V, 13 - 40V, 14 - 100V, 15 - 200V
	# cmpl                     1A       350mA     125mA         50mA
	if (ch == 28):
	    print ("\033[%d;40H \033[%d;1mVset2 = %3.5E V, %s ILIM = 20 mA\033[39;0m" % (12, 33, value, rng_str[rang]))
	elif (ch == 18):
	    print ("\033[%d;40H \033[%d;1mVset1 =  %3.5E V, %s ILIM = 20 mA\033[39;0m" % (11, 33, value, rng_str[rang]))
	self.inst.write("DV%d,%d,%9.6e\n" % (ch, rang, value))

    def vm_mode(self, ch, mode):
	self.inst.write("VM%d,%d\n" % (ch, mode))

    def src_zero(self, ch):
	self.inst.write("DZ%d\n" % (ch))

    def read_data(self,cmd,ch):
        data_float = 0.0
        data_str = ""
        self.inst.write(cmd)
        try:
            with Timeout(90):
                data_str = self.inst.read()
        except Timeout.Timeout:
            print ("Timeout exception from dmm %s on read_data() inst.read()\n" % self.name)
            return (0,float(0))
        #print ("Reading from dmm %s = %s" % (self.name,data_str))
        try:
            data_float = float(data_str)
        except ValueError:
            print("\033[%d;130H %s read_data() - Value = %s" % (ch+1,self.name,data_str))
	    data_float = float(data_str[3:])
	    #print ("\033[20;20H %s" % data_str[2:3])
	    if (data_str[2:3] == "I"):
		print ("\033[%d;28H\033[44;36m Imeas \033[49;39m" % (ch+1))
	    elif (data_str[2:3] == "V"):
		print ("\033[%d;28H\033[44;36m Vmeas \033[49;39m" % (ch+1))

	    if (data_str[0:1] == "N"):
		print ("\033[%d;14H\033[42;30m\033[5m OPERATING \033[49;39m\033[0m" % (ch+1))
	    elif (data_str[0:1] == "T"):
		print ("\033[%d;14H\033[40;37m\033[5m SYS COMPL \033[49;39m\033[0m" % (ch+1))
	    elif (data_str[0:1] == "C"):
		print ("\033[%d;14H\033[46;30m\033[5m CHA COMPL \033[49;39m\033[0m" % (ch+1))
	    elif (data_str[0:1] == "V"):
		print ("\033[%d;14H\033[41;33m OVERRANGE \033[49;39m" % (ch+1))
	    elif (data_str[0:1] == "X"):
		print ("\033[%d;14H\033[41;33m UNSTABLE  \033[49;39m" % (ch+1))
	    elif (data_str[0:1] == "F"):
		print ("\033[%d;14H\033[41;33m NOT SETTL \033[49;39m" % (ch+1))
	    elif (data_str[0:1] == "W"):
		print ("\033[%d;14H\033[46;34m SWEEP STA \033[49;39m" % (ch+1))
	    elif (data_str[0:1] == "E"):
		print ("\033[%d;14H\033[46;34m SWEEP END \033[49;39m" % (ch+1))
	    elif (data_str[0:1] == "S"):
		print ("\033[%d;14H\033[45;31m AFU-TOFAS \033[49;39m" % (ch+1))

            return (0,data_str[3:]) # Exception on float conversion, 0 = error
        return (1,data_float) # Good read, 1 = converted to float w/o exception

    def get_data(self,ch):
	self.src_meas_mode(ch, 1)
	time.sleep(0.01)
        self.status_flag,data = self.read_data("XE\n",ch)
	time.sleep(0.01)
        #if (self.status_flag):
        self.data = float(data)
	print ("\033[%d;100H Value = %9.8G          " % ((ch+1), self.data) )
        return self.data

    def get_vdata(self,ch):
	self.src_meas_mode(ch, 1)
	time.sleep(0.01)
        self.inst.write("XE\n")
	time.sleep(0.01)
	if (ch == 18):
	    chx = 11
	if (ch == 28):
	    chx = 12
        try:
            with Timeout(90):
                data_str = self.inst.read()
        except Timeout.Timeout:
            print ("Timeout exception from dmm %s on read_data() inst.read()\n" % self.name)
            return (0,float(0))
        #print ("Reading from dmm %s = %s" % (self.name,data_str))
        try:
            data_float = float(data_str)
        except ValueError:
            print("\033[%d;130H %s read_data() - Value = %s" % (chx,self.name,data_str))
	    data_float = float(data_str[3:])
	    print ("\033[%d;90H %sMEAS %e" % (chx,data_str[2:3], data_float))
	    if (data_str[2:3] == "I"):
		print ("\033[%d;28H\033[44;36m Imeas \033[49;39m" % (chx))
	    elif (data_str[2:3] == "V"):
		print ("\033[%d;28H\033[44;36m Vmeas \033[49;39m" % (chx))

	    if (data_str[0:1] == "N"):
		print ("\033[%d;14H\033[42;30m\033[5m OPERATING \033[49;39m\033[0m" % (chx))
	    elif (data_str[0:1] == "V"):
		print ("\033[%d;14H\033[41;33m OVERRANGE \033[49;39m" % (chx))

            return (0,data_float) # Exception on float conversion, 0 = error
        return (1,data_float) # Good read, 1 = converted to float w/o exception

        self.data = float(data)
	print ("\033[%d;100H Value = %9.8G          " % ((chx), self.data) )
        return data_float

    def get_err(self):
        self.inst.write("ERR?\n")
        try:
            with Timeout(90):
                data_str = self.inst.read()
        except Timeout.Timeout:
            print ("Timeout exception from dmm %s on read_data() inst.read()\n" % self.name)
            return (0,float(0))
	print ("\033[1;20H ERR %18s             " % (data_str))
        return self.data

    def write_data(self,fileHandle):
	global vmeas1,vmeas2
	global curr1,curr2,curr3,curr4,volt1,volt2,volt3,volt4
	global res_delta
        print ("\033[%d;0H" % (dline + 16)) + time.strftime("%d/%m/%Y-%H:%M:%S;") + ("\033[0;33m[%8d]: \033[32;1m%12.6G \033[34;1m%12.6G \033[35;1m%12.6G \033[37;1m%12.6G V=\033[32;1m%12.6G \033[34;1m%12.6G \033[35;1m%12.6G \033[37;1m%12.6G" % (cnt, curr1, curr2, curr3, curr4, volt1,volt2,volt3,volt4  ) ),
	print ("\033[10;50H \033[33;1mEXT_T:%3.2f , RH:%3.2f , Press:%4.2f hPa\033[39;0m" % (float(exttemp),float(rh),float(hectopascals)))
        fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%10.8E;%10.8E;%10.8E;%10.8E;%10.6E;%10.6E;%10.6E;%10.6E;%6.4G;%6.4G;%6.4G;%6.4G;%5.3f;%3.2f;%4.2f;\r\n" % (curr1,curr2,curr3,curr4,volt1,volt2,volt3,volt4,volt_p1,volt_p2,vmeas1[1],vmeas2[1],float(exttemp),float(rh),float(hectopascals) ) ))


class scpi_meter():
    temp = 38.5
    data = ""
    ppm = 0.0
    status_flag = 1
    temp_status_flag = 1
    global exttemp
    global rh
    global hectopascals
    global res_rtd

    def __init__(self,gpib,reflevel,name):
        self.gpib = gpib
        self.inst = Gpib.Gpib(0,self.gpib, timeout=90) # SCPI GPIB Address = self.gpib
        self.reflevel = reflevel
        self.name = name
        self.init_inst()

    def init_inst(self):

        # Setup SCPI DMM
        self.inst.clear()
	self.inst.write("*RST")
	self.inst.write("*CLR")
        self.inst.write(":SYST:AZER:TYPE SYNC")
        self.inst.write(":SYST:LSYN:STAT ON")
	self.inst.write(":sens:temp:tran rtd")      #select thermistor
	self.inst.write(":sens:temp:rtd:type user") #10 kOhm thermistor
	self.inst.write(":sens:temp:rtd:alph 0.00375") #10 kOhm thermistor
	self.inst.write(":sens:temp:rtd:beta 0.160") #10 kOhm thermistor
	self.inst.write(":sens:temp:rtd:delt 1.605") #10 kOhm thermistor
	#self.inst.write(":sens:temp:rtd:rzer 1000") #10 kOhm thermistor
        #self.inst.write(":SENS:FUNC 'TEMP'")
        #self.inst.write(":SENS:TEMP:DIG 7")
        self.inst.write(":SENS:FUNC 'VOLT:DC'")
	self.inst.write(":SENS:VOLT:DC:DIG 9; NPLC 10; AVER:COUN 2; TCON REP")
        self.inst.write(":SENS:VOLT:DC:AVER:STAT ON")
        self.inst.write(":SENS:VOLT:DC:RANG 20") 
	#self.inst.write(":SENS:TEMP:DIG 9")
        #self.inst.write(":SENS:TEMP:NPLC 10")
        self.inst.write(":FORM:ELEM READ")
        self.inst.write(":DISP:WIND:TEXT:DATA \"               \";STAT OFF;")
        self.inst.write(":DISP:WIND2:TEXT:DATA \"               \";STAT ON;")
        #kei.write("READ?")

    def read_data(self,cmd):
        data_float = 0.0
        data_str = ""
        self.inst.write(cmd)
        try:
            with Timeout(90):
                data_str = self.inst.read()
        except Timeout.Timeout:
            print ("Timeout exception from dmm %s on read_data() inst.read()\n" % self.name)
            return (0,float(0))
        #print ("Reading from dmm %s = %s" % (self.name,data_str))
        try:
            data_float = float(data_str)
        except ValueError:
            print("Exception thrown by dmm %s on read_data() - ValueError = %s\n" % (self.name,data_str))
            return (0,float(0)) # Exception on float conversion, 0 = error
        return (1,data_float) # Good read, 1 = converted to float w/o exception

    def get_data(self):
        self.status_flag,data = self.read_data("READ?")
        if (self.status_flag):
            self.data = data
            self.ppm = ((float(self.data) / self.reflevel)-1)*1E6
	    self.res_rtd = data
        return self.data

    def get_data_status(self):
        return self.status_flag

    def write_data(self, fileHandle):
	res_rtd = self.data
	tempc = float(res_rtd)
        fileHandle.write(";%2.3f;\r\n" % tempc);
        #print time.strftime("%d/%m/%Y-%H:%M:%S;") + ("\033[1;31m[%8d]: %2.8f , dev %4.2f ppm,\033[1;39m  EXT_T:%3.2f , RH:%3.2f , Press:%4.2f hPa" % (cnt, float(self.data),float(self.ppm),float(exttemp),float(rh),float(hectopascals) ) )
        #fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%16.8f;%16.8f;%3.1f;%3.2f;%3.2f;%4.2f;\r\n" % (float(self.data),float(self.reflevel),float(self.ppm),float(exttemp),float(rh),float(hectopascals) ) ))

    def print_ppm(self):
	res_rtd = self.data
        tempc = float(res_rtd)
        print ("%2.3f" % tempc)
	self.inst.write(":DISP:WIND2:TEXT:DATA \"%2.3f    \"" % tempc)
	#self.inst.write(":DISP:WIND2:TEXT:DATA \"  \"")


class meter():
    temp = 24.0
    data = ""
    ppm = 0.0
    status_flag = 1
    temp_status_flag = 1
    global exttemp
    global rh
    global hectopascals
    global res_rtd
    global tec_rtd

    def __init__(self,gpib,refhp,name):
        self.gpib = gpib
        self.inst = Gpib.Gpib(0,self.gpib, timeout=90) # 3458A GPIB Address = self.gpib
        self.refhp = refhp
        self.name = name
        self.init_inst()

    def init_inst(self):
        # Setup HP 3458A
        self.inst.clear()
        self.inst.write("PRESET NORM")
        self.inst.write("OFORMAT ASCII")
        self.inst.write("DCI 1E-3")
        self.inst.write("TARM HOLD")
        self.inst.write("TRIG AUTO")
        self.inst.write("NPLC 100")
        self.inst.write("AZERO ON")
	self.inst.write("OCOMP OFF")
        self.inst.write("LFILTER ON")
        self.inst.write("NRDGS 1,AUTO")
        self.inst.write("MEM OFF")
        self.inst.write("END ALWAYS")
        self.inst.write("NDIG 9")
	self.inst.write("DELAY 0") # 2 second delay to mitigate OCOMP accuracy issue due DA

    def read_data(self,cmd):
        data_float = 0.0
        data_str = ""
        self.inst.write(cmd)
    	time.sleep(0.1)
        try:
            with Timeout(90):
		time.sleep(0.1)
                data_str = self.inst.read()
        except Timeout.Timeout:
            print ("Timeout exception from dmm %s on read_data() inst.read()\n" % self.name)
            return (0,float(0))
        #print ("Reading from dmm %s = %s" % (self.name,data_str))
        try:
            data_float = float(data_str)
        except ValueError:
            print("Exception thrown by dmm %s on read_data() - ValueError = %s\n" % (self.name,data_str))
            return (0,float(0)) # Exception on float conversion, 0 = error
        return (1,data_float) # Good read, 1 = converted to float w/o exception

    def get_temp(self):
        self.inst.write("TARM SGL,1")
	time.sleep(0.1)        
	self.temp_status_flag,temp = self.read_data("TEMP?")
	time.sleep(0.1)
        if (self.temp_status_flag):
            self.temp = temp
        return self.temp

    def get_temp_status(self):
        return self.temp_status_flag

    def get_data(self):
        self.status_flag,data = self.read_data("TARM SGL,1")
	time.sleep(0.1)
	global res_delta
        if (self.status_flag):
            self.data = (data)
            self.ppm = ((res_delta / self.refhp) - 1) * 1e6 #((float(self.data) / self.refhp)-1)*1E6
        return self.data

    def get_data_status(self):
        return self.status_flag

    def write_data(self,fileHandle):
	global val2, val3, val4
	global res_delta
        print time.strftime("%d/%m/%Y-%H:%M:%S;") + ("\033[1;36m[%8d]: %2.10f T-Ohm \033[1;31m%2.9e \033[1;33m%2.8f %2.8f\033[0;32m, dev %4.4f %4.4f ppm, T:%3.1f\033[1;39m , EXT_T:%3.2f , RH:%3.2f , Press:%4.2f hPa" % (cnt, res_delta,val2,val3,val4,float(self.ppm),((val2/10.0) - 1) *1E6, float(self.temp),float(exttemp),float(rh),float(hectopascals) ) )
        fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%16.8f;%16.8e;%2.8f;%2.8f;%3.1f;%4.3f;%3.2f;%3.2f;%4.2f;\r\n" % (res_delta,val2,val3,val4,float(self.temp),float(self.ppm),float(exttemp),float(rh),float(hectopascals) ) ))

    def print_ppm(self):
        #self.inst.write("DISP OFF, \"%3.3f ppm\"" % float(self.ppm))
	time.sleep(0.1)
	#self.inst.write("DISP OFF, \" \"")
	#self.inst.write("DISP OFF, \"%9.8f VREF \"" % float(self.data))

# Read Temperature, Humidity, and Barometric Pressure from BME280
def get_THP():
    global exttemp
    global rh
    global pascals
    global hectopascals
    exttemp = sensor.read_temperature()
    rh = sensor.read_humidity()
    pascals = sensor.read_pressure()
    hectopascals = pascals / 100
    time.sleep(0.1)

# Check if file exists, if not create it and add header
def create_local_file(fileName):
    if (os.path.isfile(fileName) == False):
        with open(fileName, 'a') as o:
            o.write("date;curr1;curr2;curr3;curr4;volt1;volt2;volt3;volt4;vs1;vs2;vm1;vm2;ext_temp;rh;pressure;\r\n")
            print ("file %s does not exist\r\n" % fileName) 
    else: 
        print ("file %s exists\r\n" % fileName)

#I 0 - autorange, 11 - 1nA, 12 - 10nA, 13 - 100nA, 14 - 1ua, 15 - 10ua, 16 - 100ua, 17 - 1ma, 18 - 10ma, 19 - 100ma, 20 - 1A
#V 0 - autorange, 11 - 2V, 12 - 20V, 13 - 40V, 14 - 100V, 15 - 200V

csrc = smu_src(14, refhp, "4142") # GPIB 14 A4142B # 12 Keithley 6221
print ("\033[1;70H"),
create_local_file(fileName4)
for chi in range (1,8):
    print ("\033[%d;2H\033[1;%dm SMU%d\033[39;0m" % (chi+1, chi+30, chi))

volt1 = 20.00000
volt2 = -20.00000
volt3 = 20.00000
volt4 = 1.00000

csrc.src_off(2)
csrc.src_off(4)
csrc.src_off(5)
csrc.src_off(7)

csrc.src_on(2)
csrc.src_on(4)
csrc.src_on(5)
csrc.src_on(7)

csrc.src_off(18) # Vsource 1
csrc.src_off(28) # Vsource 2

#csrc.src_volt(2, volt1, 12, 30e-9)
csrc.src_volt(4, volt2, 15, 1e-9)
#csrc.src_volt(5, volt3, 12, 30e-9)
csrc.src_volt(7, volt4, 11, 1e-9)

volt_p1 = 1.0
volt_p2 = -1.0
       
csrc.vs_volt(18, volt_p1, 13)
csrc.vs_volt(28, volt_p2, 13)
csrc.vm_mode(18, 1)
csrc.vm_mode(28, 1)

csrc.src_curr(2, 0.1000e-9, 11, 20)
#csrc.src_curr(4, -10.0000e-6, 13, 0)
csrc.src_curr(5, 10e-9, 15, 10)
#csrc.src_curr(7, 1e-9, 15, 1)

csrc.src_meas_mode(2,1) #Spot mode
csrc.src_meas_mode(4,1) #Spot mode
csrc.src_meas_mode(5,1) #Spot mode
csrc.src_meas_mode(7,1) #Spot mode

csrc.get_err()

#meter1 = meter(3,refhp,"3458A_00000") # Gpib 3
#meter2 = meter(2,refhp,"3458A_00000") # Gpib 3

#meter1.inst.write("DCI 100e-6")
#meter2.inst.write("DCV 1")
#meter2.inst.write("DELAY 0")

#meter1.inst.write("ACAL ALL")
#meter2.inst.write("ACAL ALL")
#time.sleep(860)

#meter2510 = tec_meter(25,reflevel,"2510_00000") # Gpib 25
#u6 = scpi_meter(4,reflevel,"2002_00000") # Gpib 10
#u4 = scpi_meter(6,reflevel,"2002_00000") # Gpib 10

#u6.inst.write(":SENS:FUNC 'FRES'")
#u6.inst.write(":SENS:FRES:DIG 9; NPLC 10; AVER:COUN 2; TCON REP")
#u6.inst.write(":SENS:FRES:AVER:STAT ON")
#u6.inst.write(":SENS:FRES:RANG 20E3") 

#u4.inst.write(":SENS:FUNC 'VOLT:DC'")
#u4.inst.write(":SENS:VOLT:DC:DIG 9; NPLC 10; AVER:COUN 2; TCON REP")
#u4.inst.write(":SENS:VOLT:DC:AVER:STAT ON")
#u4.inst.write(":SENS:VOLT:DC:RANG 2") 

#meter1.get_temp()
#meter2001.get_temp()
#meter3.get_temp()

#Setup temp/humidity/pressure sensor BME280
# OSAMPLE = oversampling mode
sensor = BME280(mode=BME280_OSAMPLE_8)
get_THP() # Read Temp, RH, Pressure from sensor

# Create file for 1st 3458A and write header if needed
#meter2510.cfg_temp()

temp = 29.0

#if (temp < 50):
#meter2510.inst.write(":OUTP OFF")
#meter2510.write(":DISP:WIND:TEXT:DATA \"ALL Done!\";STAT ON;")
#print ("Set Temp = %d" % temp)
#meter2510.deduct_tmp(temp)

#meter2510.print_ppm()
#Dmeter2002.print_ppm()
#meter1.print_ppm()
tread = 1000

while cnt <= 95000:
    global val2,val3,val4, dline
    global volt1,volt2,volt3,volt4
    csrc.get_err()

    cnt+=1
    dline+=1
    if (dline == 50):
	dline = 0

#    if (temp >= 55.0):
#	meter2510.off_tmp(temp)
#	quit()

#    if ((cnt % 2000) == 0):
#        temp = 29.0 + (float(cnt) / 2000)
#	print ("Set Temp = %2.1f" % temp)
#	meter2510.deduct_tmp(temp)

    with open(fileName4, 'a') as o1: # Open file handles for both files
        get_THP() # Read Temp, RH, Press from sensor
        tread = tread - 1
        if (tread == 0):
            tread = 1000
	    csrc.self_cal(2)
	    csrc.self_cal(4)
	    csrc.self_cal(5)
	    csrc.self_cal(7)

    #True ohm measurement delta
#	global res_delta
#	delta_del = 6

#	ipos = 0.10000e-3 #Source positive pulse, measure
#	csrc.src_curr(1, ipos)
#	time.sleep(delta_del)
#	res_delta1 = -(meter2.get_data() - zerov)
#	time.sleep(2)
#	res_delta1 = -(meter2.get_data() - zerov)
	
#	ineg = -0.10000e-3 #Source negative pulse, measure
#	csrc.src_curr(1, ineg)
#	time.sleep(delta_del)
#	res_delta2 = (meter2.get_data() - zerov)
#	time.sleep(2)
#	res_delta2 = (meter2.get_data() - zerov)

#	res_delta = (res_delta1 + res_delta2) / (0.1000000E-3 + 0.1000000e-3) # Final resistance calculation
#	print ("RD1 = %.7f RD2 = %.7f RD = %.7f Z = %.8f\r\n" % (res_delta1, res_delta2, res_delta, zerov))

        curr1 = csrc.get_data(2)
	curr2 = csrc.get_data(4)
#	curr3 = csrc.get_data(5)
        curr4 = csrc.get_data(7)

        curr1 += csrc.get_data(2)
	curr2 += csrc.get_data(4)
#	curr3 += csrc.get_data(5)
        curr4 += csrc.get_data(7)

        curr1 += csrc.get_data(2)
	curr2 += csrc.get_data(4)
#	curr3 += csrc.get_data(5)
        curr4 += csrc.get_data(7)

        curr1 = curr1 / 3
	curr2 = curr2 / 3
#	curr3 = curr3 / 3
        curr4 = curr4 / 3
	curr3 = 400 / -curr2

	global vmeas1,vmeas2
#	vmeas1 = 0
#	vmeas2 = 0
        vmeas1 = csrc.get_vdata(18)
        vmeas2 = csrc.get_vdata(28)
	csrc.write_data(o1)
	
        o1.close()
